from matplotlib import pyplot as plt
import scipy.io
import numpy
import os


if __name__ == '__main__':
    print "Generating neff plot..."
    
    out_path = "output"
    pics_path = "pics"

    colors = ["b", "g"]
    styles = ["--*", "--o"]
    
    files = ["results_AMIS_0",
             "results_NR_0"]
    
    ident = "Neff" #dictionary key for neff array 
 
    experiments_count = 1
    
    neffs = numpy.zeros((len(files), experiments_count, 18))
    
    for i in range(len(files)):
        d = scipy.io.loadmat(out_path+os.sep+files[i])
        neffs[i] = numpy.array(d[ident])[:,0]


    tsize1 = 18 #textsize y axis
    tsize2 = 16 #textsize x axis
    lw = 2 #linewidth
    ms = 8 #markersize

    labels = [ "AMIS", "NR"] 

    fig = plt.figure()
    ax = fig.add_subplot(111) 
    for i in range(len(files)):
        ax.semilogy(range(1,19), neffs[i][0], styles[i], linewidth=lw, markersize=ms ,label=labels[i])
    ax.set_xlim(1,18)  
    ax.set_xticks(range(1,19))
    ax.set_xticklabels(range(-5,13))
    ax.set_ylim(0,1100)  
    ax.set_ylabel(r"$n_{eff}$", size=tsize1)  
    ax.set_xlabel(r"time step, $t$", size=tsize2)
    ax.legend(loc='best')
    ax.grid()
    ax.set_title("Case B: Unknown release start and duration\n Q=[0,0,0,0,0,0,1,5,4,3,2,1,0,0,0,0,0,0]xE16 Bq")

    plt.savefig(pics_path+os.sep+'neff.pdf')
    print "Saved file %s." % (pics_path+os.sep+'neff.pdf')
    