#cython: boundscheck=False
cimport math
cimport numpy as np
cimport cython
from puff_tools cimport Puff



# Workaround: Cython nepovolí double[:] uvnitř @cython.locals()
ctypedef double[:] double_1D
ctypedef double[:, :] double_2D

#@cython.locals(dose_at_receptors = double_2D, Qi_inventories = double_1D, ci_of_receptors = double_2D,
#    tt = int, i = int, j = int, puff = Puff, ws = double, wd = double,
#    xrec = double, yrec = double, zrec = double)
#cdef double[:, :] propagate_puff_model_external_Cython(j, total_time_global, Puff[:] PUFFS, double[:, :] receptors,
#    double doseA, double doseB, double doseMJU, double doseMJUaE, double doseCb, double dose_integration_time,
#    int dose_sub_step_no, int n, bint obs_meteo_flag, #int dose_sub_step_no, int n, METEO_FORECAST, bint obs_meteo_flag,
#    double[:] METEO_OBS_WS, double[:] METEO_OBS_WD)

#@cython.locals(x = double, y = double)
#cdef double get_dose_at_receptor(int tt, Puff puff, double xrec, double yrec, double zrec,
#    double doseA, double doseB, double doseMJU, double doseMJUaE, double doseCb,
#    double mix_layer_height, double partial_time, int n) nogil

#cdef double[:] GLq_weights, GLq_absicas

#@cython.locals(ret1 = double, ret2 = double, ret3 = double,
#    x = double, y = double, z = double)
#cdef double Gauss_Legendre_quadrature_3D(int tt, Puff puff, double xrec, double yrec, double zrec,
#    double doseA, double doseB, double doseMJU, double mix_layer_height, int n) nogil

#cdef double get_gamma_flux_rate_argument_poklicka(int tt, Puff puff, double r, double th,
#    double phi, double xrec, double yrec, double zrec, double doseA, double doseB, double doseMJU,
#    double mix_layer_height) nogil

@cython.locals(xToPuff = double, yToPuff = double, factor0 = double, factor1 = double,
    factor2 = double, factor3 = double)
cdef double get_conc_at_location(double Q, double x0, double y0, double H, double dd_total,
    double rd_total, double sigmaxy, double sigmaz, double xrec, double yrec, double zrec,
    double mix_layer_height) nogil

@cython.locals(ret = double)
cdef double getReflectionAtTheTopOfMixingLayerZ(double M, double z, double sz, double H) nogil

@cython.locals(ret = double)
cdef double vertFactReflGroundZ(double z, double sz, double H) nogil

##########################RH
#cdef double[:] cats
#cdef double getMixingLayerHeight(int Pcategory, double[:,:] data) nogil - DEPRECATED

#cdef double[:] sigmaxyA, sigmaxyB, sigmazA, sigmazB,
@cython.locals(s1 = double)
cdef double get_dispersion_coefs_sXY(double totDist, int Pcategory, double[:,:] data) nogil
cdef double get_dispersion_coefs_sZ(double totDist, int Pcategory, double[:,:] data) nogil

@cython.locals(partial_time = double, grid_step = double, t = int, i = int, pN = int, #puff = double_1D,
    pi = int, wd = double, ws = double, dx = double, dy = double, mix_layer_height = double, j = int,
    xrec = double, yrec = double, zrec = double, ci = double)   
cdef double[:,:] propagate_puff_model_external_Cython(int id, int tt, int t_meteo, double total_time_global, double[:, :] PUFFS, int[:] STABS, double[:, :] receptors,
    double doseA, double doseB, double doseMJU, double doseMJUaE, double doseCb, double dose_integration_time,
    int dose_sub_step_no, int n, double[:,:,:,:] METEO_FORECAST, bint obs_meteo_flag, 
    double[:] METEO_OBS_WS, double[:] METEO_OBS_WD, double[:,:] sig_coe_mx_lay_he) nogil

@cython.locals(ret = double)
cdef double getDryDepo(double delta_time, double deltaSigmaz, double vG, double H) nogil

@cython.locals(x = double, y = double)
cdef double get_dose_at_receptor(int tt, double[:] puff, double xrec, double yrec, double zrec,
    double doseA, double doseB, double doseMJU, double doseMJUaE, double doseCb,
    double mix_layer_height, double partial_time, int n) nogil

cdef double[:] GLq_weights_5, GLq_absicas_5, GLq_weights_12, GLq_absicas_12, GLq_weights_20, GLq_absicas_20

@cython.locals(ret1 = double, ret2 = double, ret3 = double,
    x = double, y = double, z = double, GLq_weights = double_1D, GLq_absicas = double_1D)
cdef double Gauss_Legendre_quadrature_3D(int tt, double[:] puff, double xrec, double yrec, double zrec,
    double doseA, double doseB, double doseMJU, double mix_layer_height, int n) nogil

cdef double get_gamma_flux_rate_argument(int tt, double[:] puff, double r, double th,
    double phi, double xrec, double yrec, double zrec, double doseA, double doseB, double doseMJU,
    double mix_layer_height) nogil

cdef double bilinear_interp(double q11, double q12, double q21, double q22, double x1, double y1, double x2, double y2, double x, double y) nogil

@cython.locals(x = double, y = double, ws_0 = double, ws_1 = double)
cdef double get_meteo_ws(double[:,:,:,:] METEO, double grid_step, int t0, double total_time_global, double X, double Y) nogil

@cython.locals(x = double, y = double, wd_0 = double, wd_1 = double)
cdef double get_meteo_wd(double[:,:,:,:] METEO, double grid_step, int t0, double total_time_global, double X, double Y) nogil


cdef double propagate_puff_model_external_Cython2(int id) nogil